# azure_mgmt_authorization crate

This is a generated [Azure SDK for Rust](https://github.com/Azure/azure-sdk-for-rust) crate from the Azure REST API specifications listed in:

https://github.com/Azure/azure-rest-api-specs/blob/main/specification/authorization/resource-manager/readme.md

To get started with these generated service crates, see the [examples](https://github.com/Azure/azure-sdk-for-rust/blob/main/services/README.md#examples).

The default tag is `package-2020-10-01`.

The following [tags](https://github.com/Azure/azure-sdk-for-rust/blob/main/services/tags.md) are available:

- `package-2020-10-01` has 48 operations from 2 API versions: `2015-07-01`, `2020-10-01`. Use crate feature `package-2020-10-01` to enable. The operations will be in the `package_2020_10_01` module.
- `package-2020-10-01-only` has 27 operations from 1 API versions: `2020-10-01`. Use crate feature `package-2020-10-01-only` to enable. The operations will be in the `package_2020_10_01_only` module.
- `package-2022-04-01-preview-only` has 10 operations from 1 API versions: `2022-04-01-preview`. Use crate feature `package-2022-04-01-preview-only` to enable. The operations will be in the `package_2022_04_01_preview_only` module.
- `package-2021-01-01-preview-only` has 13 operations from 1 API versions: `2021-01-01-preview`. Use crate feature `package-2021-01-01-preview-only` to enable. The operations will be in the `package_2021_01_01_preview_only` module.
- `package-2020-10-01-preview-only` has 37 operations from 1 API versions: `2020-10-01-preview`. Use crate feature `package-2020-10-01-preview-only` to enable. The operations will be in the `package_2020_10_01_preview_only` module.
- `profile-hybrid-2020-09-01` has 20 operations from 1 API versions: `2015-07-01`. Use crate feature `profile-hybrid-2020-09-01` to enable. The operations will be in the `profile_hybrid_2020_09_01` module.
- `package-2020-08-01-preview` has 30 operations from 6 API versions: `2015-06-01`, `2015-07-01`, `2018-01-01-preview`, `2018-07-01-preview`, `2019-08-01-preview`, `2020-08-01-preview`. Use crate feature `package-2020-08-01-preview` to enable. The operations will be in the `package_2020_08_01_preview` module.
- `package-2020-04-01-preview` has 28 operations from 6 API versions: `2015-06-01`, `2015-07-01`, `2018-01-01-preview`, `2018-07-01-preview`, `2019-08-01-preview`, `2020-04-01-preview`. Use crate feature `package-2020-04-01-preview` to enable. The operations will be in the `package_2020_04_01_preview` module.
- `package-2020-04-01-preview-only` has 10 operations from 1 API versions: `2020-04-01-preview`. Use crate feature `package-2020-04-01-preview-only` to enable. The operations will be in the `package_2020_04_01_preview_only` module.
- `package-2020-03-01-preview` has 28 operations from 6 API versions: `2015-06-01`, `2015-07-01`, `2018-01-01-preview`, `2018-07-01-preview`, `2019-08-01-preview`, `2020-03-01-preview`. Use crate feature `package-2020-03-01-preview` to enable. The operations will be in the `package_2020_03_01_preview` module.
- `package-2019-08-01-preview-only` has 1 operations from 1 API versions: `2019-08-01-preview`. Use crate feature `package-2019-08-01-preview-only` to enable. The operations will be in the `package_2019_08_01_preview_only` module.
- `profile-hybrid-2019-03-01` has 20 operations from 1 API versions: `2015-07-01`. Use crate feature `profile-hybrid-2019-03-01` to enable. The operations will be in the `profile_hybrid_2019_03_01` module.
- `package-2018-09-01-preview` has 27 operations from 5 API versions: `2015-06-01`, `2015-07-01`, `2018-01-01-preview`, `2018-07-01-preview`, `2018-09-01-preview`. Use crate feature `package-2018-09-01-preview` to enable. The operations will be in the `package_2018_09_01_preview` module.
- `package-2018-09-01-preview-only` has 10 operations from 1 API versions: `2018-09-01-preview`. Use crate feature `package-2018-09-01-preview-only` to enable. The operations will be in the `package_2018_09_01_preview_only` module.
- `package-2018-07-01-preview` has 27 operations from 4 API versions: `2015-06-01`, `2015-07-01`, `2018-01-01-preview`, `2018-07-01-preview`. Use crate feature `package-2018-07-01-preview` to enable. The operations will be in the `package_2018_07_01_preview` module.
- `package-2018-07-01-preview-only` has 6 operations from 1 API versions: `2018-07-01-preview`. Use crate feature `package-2018-07-01-preview-only` to enable. The operations will be in the `package_2018_07_01_preview_only` module.
- `package-2018-01-01-preview` has 21 operations from 3 API versions: `2015-06-01`, `2015-07-01`, `2018-01-01-preview`. Use crate feature `package-2018-01-01-preview` to enable. The operations will be in the `package_2018_01_01_preview` module.
- `package-2018-01-01-preview-only` has 19 operations from 1 API versions: `2018-01-01-preview`. Use crate feature `package-2018-01-01-preview-only` to enable. The operations will be in the `package_2018_01_01_preview_only` module.
- `package-2017-10-01-preview` has 21 operations from 3 API versions: `2015-06-01`, `2015-07-01`, `2017-10-01-preview`. Use crate feature `package-2017-10-01-preview` to enable. The operations will be in the `package_2017_10_01_preview` module.
- `package-2017-10-01-preview-only` has 10 operations from 1 API versions: `2017-10-01-preview`. Use crate feature `package-2017-10-01-preview-only` to enable. The operations will be in the `package_2017_10_01_preview_only` module.
- `package-2015-07-01` has 21 operations from 1 API versions: `2015-07-01`. Use crate feature `package-2015-07-01` to enable. The operations will be in the `package_2015_07_01` module.
- `package-2015-06-01-preview` has 1 operations from 1 API versions: `2015-06-01`. Use crate feature `package-2015-06-01-preview` to enable. The operations will be in the `package_2015_06_01_preview` module.